
import logging
import sys
from apgl.graph import *
from apgl.generator import *
from apgl.util import *

logging.basicConfig(stream=sys.stdout, level=logging.INFO)

class GraphStatisticsProfile:
    def __init__(self):
        numVertices = 1000
        numFeatures = 0
        vList = VertexList(numVertices, numFeatures)
        graph = SparseGraph(vList)
        generator = ErdosRenyiGenerator(graph)

        p = 0.4
        self.graph = generator.generateGraph(p)

        self.statistics = GraphStatistics()

    def profileScalarStatistics(self):
        ProfileUtils.profile('self.statistics.scalarStatistics(self.graph)', globals(), locals())


profiler = GraphStatisticsProfile()
profiler.profileScalarStatistics()