"""
Some code to profile the the JacardEdgePredictor class
"""

import numpy
import logging
import sys
import cProfile
import pstats
from apgl.graph import *
from apgl.util import *
from apgl.predictors.JacardEdgePredictor import JacardEdgePredictor

logging.basicConfig(stream=sys.stdout, level=logging.INFO)

numVertices = 500
numFeatures = 0
vList = VertexList(numVertices, numFeatures)
graph = SparseGraph(vList)
generator = ErdosRenyiGenerator(graph)

p = 0.1

graph = generator.generateGraph(p)

outputDirectory = PathDefaults.getOutputDir()
directory = PathDefaults.getTempDir()
profileFileName = directory + "profile.cprof"

windowSize = 50 
predictor = JacardEdgePredictor()
vertexIndices = numpy.arange(0, 100)

cProfile.runctx('predictor.predictEdges(graph, vertexIndices, windowSize)', globals(), locals(), profileFileName)
stats = pstats.Stats(profileFileName)
stats.strip_dirs().sort_stats("cumulative").print_stats(20)

#Can't think of a way to make it any faster other than an algorithmic change