import os
import pstats
import cProfile
from apgl.predictors.LibSVM import LibSVM
from apgl.data.ExamplesGenerator import ExamplesGenerator
 

numExamples = 1000
numFeatures = 100
eg = ExamplesGenerator()

examplesList = eg.generateBinaryExamples(numExamples, numFeatures)
svm = LibSVM()
svm.learnModel(examplesList)

profileFileName = "profile.cprof"
cProfile.runctx('svm.classify(examplesList)', globals(), locals(), profileFileName)
stats = pstats.Stats(profileFileName)
stats.strip_dirs().sort_stats("cumulative").print_stats(20)
os.remove(profileFileName)