
import unittest
import numpy
from apgl.predictors.PrimalRidgeRegression import PrimalRidgeRegression
from apgl.util.Util import Util

 


class  PrimalRidgeRegressionTest(unittest.TestCase):
    def setUp(self):
        pass

    def testLearnModel(self):
        numExamples = 10
        numFeatures = 10

        X = numpy.random.rand(numExamples, numFeatures)
        Y = X

        lmbda = 0.5
        tol = 10-6 

        predictor = PrimalRidgeRegression(lmbda)
        U = predictor.learnModel(X, Y)


        self.assertTrue(numpy.linalg.norm(numpy.dot(X, U) - Y) < tol)
        self.assertTrue(numpy.linalg.norm(predictor.predict(X) - Y) < tol)

        predictor = PrimalRidgeRegression(0.0)
        U = predictor.learnModel(X, Y)

        self.assertTrue(numpy.linalg.norm(U - numpy.eye(numExamples)) < tol)

        #Test case in which y is a single feature
        y = numpy.random.rand(numExamples, 1)

        predictor = PrimalRidgeRegression(0.0)
        U = predictor.learnModel(X, y)

if __name__ == '__main__':
    unittest.main()

