"""
Test the incremental clustering algorithm for graphs
"""
from apgl.util.Util import Util
import numpy
import scipy.linalg

def computeB(A):
    """
    Find modularity matrix 
    """
    d = numpy.sum(A, 0)
    P = numpy.outer(d, d)
    return A - P 

numpy.set_printoptions(suppress=True)
#First define an adjacency matrix

A = numpy.zeros((6,6))
A[0, :] = numpy.array([0,0,1,0,1,0])
A[1, :] = numpy.array([0,0,1,1,0,1])
A[2, :] = numpy.array([1,1,0,0,1,0])
A[3, :] = numpy.array([0,1,0,0,0,1])
A[4, :] = numpy.array([1,0,1,0,0,0])
A[5, :] = numpy.array([0,1,0,1,0,0])

print(A)



#Start with i = 3
i = 3
Bi = computeB(A[0:3, 0:3])
print(Bi)

V, D = numpy.linalg.eig(Bi)
print(V)
print(D)

tol = 10**-4
vi = numpy.ones(3)
lmbdai = 1
vLast = numpy.zeros(3)

while numpy.abs(numpy.abs(numpy.dot(vLast, vi))-1) > tol:
    vLast = vi
    vi = numpy.dot(Bi, vi)
    vi = vi/numpy.linalg.norm(vi)
    lmbdai = numpy.dot(vi.T, numpy.dot(Bi, vi))

print(vi)

#Now compute next eigenvector
