import unittest
import numpy
import logging
from apgl.util import *

class  LatexTest(unittest.TestCase):
    def testArray1DToLatex(self):
        X = numpy.array([1.2323132, 5.324323, 8.3213232])
        self.assertEquals(Latex.array1DToRow(X, 3), "1.232 & 5.324 & 8.321")

        X = numpy.array([1, 2, 3], numpy.int)
        self.assertEquals(Latex.array1DToRow(X, 3), "1 & 2 & 3")

    def testArray2DToLatex(self):
        X = numpy.random.rand(5, 5)

        logging.debug((Latex.array2DToRows(X, 5)))

    def testListToLatex(self):
        lst = ["one", "two", "three"]

        self.assertEquals(Latex.listToRow(lst), "one & two & three\\\\")

        lst = []

        self.assertEquals(Latex.listToRow(lst), "")

if __name__ == '__main__':
    unittest.main()

