
import unittest
from apgl.util import * 


class  SamplingTest(unittest.TestCase):
    def testCrossValidation(self):
        numExamples = 10
        folds = 2

        indices = Sampling.crossValidation(folds, numExamples)

        self.assertEquals(indices[0], ([5, 6, 7, 8, 9], [0, 1, 2, 3, 4]))
        self.assertEquals(indices[1], ([0, 1, 2, 3, 4], [5, 6, 7, 8, 9]))

        indices = Sampling.crossValidation(3, numExamples)

        self.assertEquals(indices[0], ([3, 4, 5, 6, 7, 8, 9], [0, 1, 2]))
        self.assertEquals(indices[1], ([0, 1, 2, 6, 7, 8, 9], [3, 4, 5]))
        self.assertEquals(indices[2], ([0, 1, 2, 3, 4, 5, 9], [6, 7, 8]))

        indices = Sampling.crossValidation(numExamples, numExamples)
        self.assertEquals(indices[0], ([1, 2, 3, 4, 5, 6, 7, 8, 9], [0]))
        self.assertEquals(indices[1], ([0, 2, 3, 4, 5, 6, 7, 8, 9], [1]))
        self.assertEquals(indices[2], ([0, 1, 3, 4, 5, 6, 7, 8, 9], [2]))
        self.assertEquals(indices[3], ([0, 1, 2, 4, 5, 6, 7, 8, 9], [3]))
        self.assertEquals(indices[4], ([0, 1, 2, 3, 5, 6, 7, 8, 9], [4]))

        self.assertRaises(ValueError, Sampling.crossValidation, numExamples+1, numExamples)
        self.assertRaises(ValueError, Sampling.crossValidation, 0, numExamples)
        self.assertRaises(ValueError, Sampling.crossValidation, -1, numExamples)
        self.assertRaises(ValueError, Sampling.crossValidation, folds, 1)

if __name__ == '__main__':
    unittest.main()

