import logging
import sys
import numpy

from apgl.graph import *
from apgl.util import *
from apgl.viroscopy.model.HIVEpidemicModel import HIVEpidemicModel
from apgl.viroscopy.model.HIVGraph import HIVGraph
from apgl.viroscopy.model.HIVRates import HIVRates

logging.basicConfig(stream=sys.stdout, level=logging.INFO)
numpy.random.seed(24)

class HIVEpidemicModelProfile():
    def __init__(self):
        #Total number of people in population
        M = 10000
        numInitialInfected = 5

        #The graph is one in which edges represent a contact
        undirected = True
        self.graph = HIVGraph(M, undirected)

        for i in range(M):
            if i < numInitialInfected:
                self.graph.getVertexList().setInfected(i, 0.0)


    def profileSimulate(self):
        #End time
        T = 200.0

        rates = HIVRates(self.graph)
        model = HIVEpidemicModel(self.graph, rates)
        model.setT(T)

        ProfileUtils.profile('model.simulate()', globals(), locals())

profiler = HIVEpidemicModelProfile()
profiler.profileSimulate()

#INFO:root:t=200.012646781 S=8559 I=1371 R=70